Subject: Re: [PATCH net-next] net: vxge: Add MODULE_FIRMWARE

From: Tim Gardner <[email-masked]>
Date: Mon, 16 Apr 2012 08:52:07 -0600

On 04/16/2012 08:29 AM, Ben Hutchings wrote:
>> 
>> I guess I'm confused about use of the MODULE_FIRMWARE() macro. I 
>> thought it merely described the names of the firmware files that
>> were actually used by the driver and had no run-time impact.
>> Regardless of whether firmware files are used on every load, why
>> _not_ describe them to modinfo ?
> [...]
> 
> Ah, that's a good question.  Quoting my own interpretation from 
> <1257629601.15927.361.camel@localhost>:
> 
>> Drivers that must load 'firmware' into the devices they drive
>> should declare the names of the files they will request, using
>> the MODULE_FIRMWARE() macro.  This enables other tools to
>> discover these dependencies statically, and warn the user if
>> firmware files are missing.
> 
> In Debian we use this to decide which files need to be copied into
> an initramfs.  You use that too unless you've changed this feature
> of initramfs-tools.  We warn when building an initramfs and during
> a major kernel upgrade if it looks like a driver will be used and
> the corresponding firmware isn't installed.
> 

Yep, we've merged "initramfs-tools (0.99) unstable" into precise. I'll
assume it behaves as described. The Ubuntu server installer will
certainly annoy you if firmware is missing. Its likely the LiveCD will
as well.

> I also have an (unfinished) patch that will use this information
> for CONFIG_FIRMWARE_IN_KERNEL.
> 
> In this case the firmware files are used to upgrade old flash, but
> since the vendor has closed down there aren't going to be any
> further updates. So the likelihood of the files actually being
> needed by the driver is very small.
> 
> Ben.
> 

I didn't realize the vendor is defunct, so I suddenly don't care as much.

rtg
- -- 
Tim Gardner [email-masked]